Package net.sf.saxon.option.dom4j

## Class DOM4JNodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.dom4j.DOM4JNodeWrapper

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `SteppingNode<DOM4JNodeWrapper>`, `SiblingCountingNode`, `VirtualNode`, `org.xml.sax.Locator`

      public class DOM4JNodeWrapper
      extends AbstractNodeWrapper
      implements SiblingCountingNode, SteppingNode<DOM4JNodeWrapper>

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This is the implementation of the NodeInfo interface used as a wrapper for DOM4J nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `index` |
    `protected org.dom4j.Node` | `node` |
    `protected short` | `nodeKind` |

    - ### Fields inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `treeInfo`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `DOM4JNodeWrapper​(org.dom4j.Node node, DOM4JNodeWrapper parent, int index)` | This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `boolean` | `equals​(java.lang.Object other)` | Determine whether this is the same node as another node.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `DOM4JNodeWrapper` | `getFirstChild()` | Get the first child of this node
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `DOM4JNodeWrapper` | `getNextSibling()` | Get the next sibling of this node
    `int` | `getNodeKind()` | Return the type of node.
    `DOM4JNodeWrapper` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix part of the name of this node.
    `DOM4JNodeWrapper` | `getPreviousSibling()` | Get the previous sibling of this node
    `NodeInfo` | `getRoot()` | Get the root node - always a document node with this tree implementation
    `int` | `getSiblingPosition()` | Get the index position of this node among its siblings (starting from 0)
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of the item as a CharSequence.
    `DOM4JNodeWrapper` | `getSuccessorElement​(DOM4JNodeWrapper anchor, java.lang.String uri, java.lang.String local)` | Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `DOM4JDocumentWrapper` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `org.dom4j.Node` | `getUnderlyingNode()` | Get the underlying DOM4J node, to implement the VirtualNode interface
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `protected AxisIterator` | `iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over the nodes reached by the given axis from this node //@param axisNumber the axis to be used
    `protected AxisIterator` | `iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the children of this node.
    `protected AxisIterator` | `iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean includeSelf)` | Return an iterator over the descendants of this node.
    `protected AxisIterator` | `iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean forwards)` | Return an iterator over the siblings of this node.
    `protected static DOM4JNodeWrapper` | `makeWrapper​(org.dom4j.Node node, DOM4JDocumentWrapper docWrapper)` | Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
    `protected static DOM4JNodeWrapper` | `makeWrapper​(org.dom4j.Node node, DOM4JDocumentWrapper docWrapper, DOM4JNodeWrapper parent, int index)` | Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
    `void` | `setSystemId​(java.lang.String uri)` | Set the system ID.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `atomize, getBaseURI, getColumnNumber, getFingerprint, getLineNumber, getNamePool, getRealNode, getStringValue, hasFingerprint, hashCode, iterateAxis, iterateAxis, saveLocation`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.s9api.Location

      `saveLocation`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, attributes, children, children, copy, getBaseURI, getColumnNumber, getConfiguration, getFingerprint, getGenre, getLineNumber, getPublicId, getSchemaType, getStringValue, hasFingerprint, hashCode, isId, isIdref, isNilled, isSameNodeInfo, isStreamed, iterateAxis, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### node

          protected org.dom4j.Node node

    - #### nodeKind

          protected short nodeKind

    - #### index

          protected int index

  - ### Constructor Detail

    - #### DOM4JNodeWrapper

          protected DOM4JNodeWrapper​(org.dom4j.Node node,
                                     DOM4JNodeWrapper parent,
                                     int index)

      This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class
      Parameters:
        `node` - The DOM4J node to be wrapped
        `parent` - The NodeWrapper that wraps the parent of this node
        `index` - Position of this node among its siblings

  - ### Method Detail

    - #### makeWrapper

          protected static DOM4JNodeWrapper makeWrapper​(org.dom4j.Node node,
                                                        DOM4JDocumentWrapper docWrapper)

      Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The DOM4J node
        `docWrapper` - The wrapper for the Document containing this node
      Returns:
        The new wrapper for the supplied node

    - #### makeWrapper

          protected static DOM4JNodeWrapper makeWrapper​(org.dom4j.Node node,
                                                        DOM4JDocumentWrapper docWrapper,
                                                        DOM4JNodeWrapper parent,
                                                        int index)

      Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The DOM4J node
        `docWrapper` - The wrapper for the Document containing this node
        `parent` - The wrapper for the parent of the DOM4J node
        `index` - The position of this node relative to its siblings
      Returns:
        The new wrapper for the supplied node

    - #### getTreeInfo

          public DOM4JDocumentWrapper getTreeInfo()

      Description copied from interface: `NodeInfo`
      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Overrides:
        `getTreeInfo` in class `AbstractNodeWrapper`
      Returns:
        the TreeInfo

    - #### getUnderlyingNode

          public org.dom4j.Node getUnderlyingNode()

      Get the underlying DOM4J node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Overrides:
        `getSystemId` in class `AbstractNodeWrapper`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### setSystemId

          public void setSystemId​(java.lang.String uri)

      Description copied from class: `AbstractNodeWrapper`
      Set the system ID. Required because NodeInfo implements the JAXP Source interface
      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`
      Overrides:
        `setSystemId` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the system ID.

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Description copied from interface: `Item`
      Get the string value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String. The method satisfies the rule that `X.getStringValueCS().toString()` returns a string that is equal to `X.getStringValue()`.

      Note that two CharSequence values of different types should not be compared using equals(), and for the same reason they should not be used as a key in a hash table.

      If the calling code can handle any CharSequence, this method should be used. If the caller requires a string, the `Item.getStringValue()` method is preferred.

      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix part of the name of this node. This is the name before the ":" if any. (Note, this method isn't required as part of the NodeInfo interface.)
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        the prefix part of the name. For an unnamed node, return an empty string.

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public DOM4JNodeWrapper getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Specified by:
        `getParent` in interface `SteppingNode<DOM4JNodeWrapper>`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0)
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over the nodes reached by the given axis from this node //@param axisNumber the axis to be used
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.

    - #### iterateChildren

          protected AxisIterator iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                 boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                    boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Overrides:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node - always a document node with this tree implementation
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the containing document

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a Buffer to contain a string that uniquely identifies this node, across all documents

    - #### getNextSibling

          public DOM4JNodeWrapper getNextSibling()

      Description copied from interface: `SteppingNode`
      Get the next sibling of this node
      Specified by:
        `getNextSibling` in interface `SteppingNode<DOM4JNodeWrapper>`
      Returns:
        the next sibling if there is one, or null otherwise

    - #### getPreviousSibling

          public DOM4JNodeWrapper getPreviousSibling()

      Description copied from interface: `SteppingNode`
      Get the previous sibling of this node
      Specified by:
        `getPreviousSibling` in interface `SteppingNode<DOM4JNodeWrapper>`
      Returns:
        the previous sibling if there is one, or null otherwise

    - #### getFirstChild

          public DOM4JNodeWrapper getFirstChild()

      Description copied from interface: `SteppingNode`
      Get the first child of this node
      Specified by:
        `getFirstChild` in interface `SteppingNode<DOM4JNodeWrapper>`
      Returns:
        the first child if there is one, or null otherwise

    - #### getSuccessorElement

          public DOM4JNodeWrapper getSuccessorElement​(DOM4JNodeWrapper anchor,
                                                      java.lang.String uri,
                                                      java.lang.String local)

      Description copied from interface: `SteppingNode`
      Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
      Specified by:
        `getSuccessorElement` in interface `SteppingNode<DOM4JNodeWrapper>`
      Parameters:
        `anchor` - the root of the tree within which navigation is confined
        `uri` - the required namespace URI, or null if any namespace is acceptable
        `local` - the required local name, or null if any local name is acceptable
      Returns:
        the next element after this one in document order, with the given URI and local name if specified, or null if this is the last node in the document, or the last node within the subtree being navigated

    - #### equals

          public boolean equals​(java.lang.Object other)

      Determine whether this is the same node as another node. Note: a.equals(b) if and only if generateId(a)==generateId(b). This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `AbstractNodeWrapper`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Overrides:
        `getAllNamespaces` in class `AbstractNodeWrapper`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.